%define url_ver %(echo %{version}|cut -d. -f1,2)

#gw this was required since 2.23.2 (new atomic OPs?)
%if %{_use_internal_dependency_generator}
%define __noautoreq 'GLIBC_PRIVATE|python\\(abi\\)'
%else
%define _requires_exceptions GLIBC_PRIVATE
%endif

%bcond_with gtkdoc

# gw bootstrap: fam pulls glib2, so build without fam
%bcond_with bootstrap

%{?build_selinux}%{?!build_selinux:%bcond_with selinux}

# Note that this is NOT a relocatable package
%define api	2.0
%define major	0
%define libname		%mklibname %{name}_ %{major}
%define libgio		%mklibname gio %{api} %{major}
%define libgmodule	%mklibname gmodule %{api} %{major}
%define libgthread	%mklibname gthread %{api} %{major}
%define libgobject	%mklibname gobject %{api} %{major}
%define devname		%mklibname %{name} -d
%if %{_lib} == lib
%define	bit	32
%else
%define	bit	64
%endif
%define gio	gio2.0-%{bit}

Summary:	GIMP Toolkit and GIMP Drawing Kit support library
Name:		glib%{api}
Epoch:		1
Version:	2.54.2
Release:	2
License:	LGPLv2+
Group:		System/Libraries
Url:		http://www.gtk.org
Source0:	ftp://ftp.gnome.org/pub/GNOME/sources/glib/%{url_ver}/glib-%{version}.tar.xz
Source1:	glib20.sh
Source2:	glib20.csh
Patch0:		glib-2.54.2-no-warnings.patch
Patch1:		0001-Bug-730332-glib-uses-wrong-timezone-transition-with-.patch
Patch2:		0002-Bug-730332-Guard-against-reading-past-the-end-of-a-t.patch
BuildRequires:	gettext
BuildRequires:  gtk-doc
BuildRequires:	libtool >= 1.4.2-2
BuildRequires:	locales-en
BuildRequires:	docbook-dtd412-xml
BuildRequires:	docbook-xsl, xsltproc
BuildRequires:	pkgconfig(dbus-1)
BuildRequires:	pkgconfig(libffi)
BuildRequires:	pkgconfig(libpcre) >= 8.11
BuildRequires:	pkgconfig(mount)
BuildRequires:	pkgconfig(zlib)
%if %{without bootstrap}
BuildRequires:	pkgconfig(gamin)
%endif
%if %{with gtkdoc}
BuildRequires:	pkgconfig(gtk-doc) >= 0.10
%endif
Requires:	pkgconfig(shared-mime-info) >= 0.70

%description
Glib is a handy library of utility functions. This C
library is designed to solve some portability problems
and provide other useful functionality which most
programs require.

Glib is used by GDK, GTK+ and many applications.
You should install Glib because many of your applications
will depend on this library.

#----------------------------------------------------------------------------

%package common
Summary:	Data files used by glib
Group:		System/Libraries

%description common
Glib is a handy library of utility functions. This C
library is designed to solve some portability problems
and provide other useful functionality which most
programs require.

Glib is used by GDK, GTK+ and many applications.
You should install Glib because many of your applications
will depend on this library.

This package contains data used by glib library.

%files common -f glib20.lang
%doc README
%config(noreplace) %{_sysconfdir}/profile.d/*
%{_datadir}/bash-completion/completions/gdbus
%{_datadir}/bash-completion/completions/gsettings
%{_datadir}/bash-completion/completions/gapplication
%{_bindir}/gdbus
%{_bindir}/gio
%{_bindir}/glib-compile-schemas
%{_bindir}/gsettings
%{_bindir}/gapplication
%{_mandir}/man1/glib-compile-schemas.1*
%{_mandir}/man1/gsettings.1*
%{_mandir}/man1/gdbus.1*
%{_mandir}/man1/gio.1*
%{_mandir}/man1/gapplication.1.xz
%{_datadir}/gettext/its/gschema.*
%dir %{_datadir}/glib-2.0/
%dir %{_datadir}/glib-2.0/schemas/
%{_datadir}/glib-2.0/schemas/gschema.dtd
%{_datadir}/glib-2.0/valgrind/glib.supp
%ghost %{_datadir}/glib-2.0/schemas/gschemas.compiled

%post common
%{_bindir}/glib-compile-schemas --allow-any-name %{_datadir}/glib-2.0/schemas/

%triggerin common -- %{_datadir}/glib-2.0/schemas/*.xml
%{_bindir}/glib-compile-schemas --allow-any-name %{_datadir}/glib-2.0/schemas/

%triggerpostun common -- %{_datadir}/glib-2.0/schemas/*.xml
%{_bindir}/glib-compile-schemas --allow-any-name %{_datadir}/glib-2.0/schemas/

#----------------------------------------------------------------------------

%package -n %{libname}
Summary:	%{summary}
Group:		%{group}
Provides:	glib2 = %{EVRD}

%description -n %{libname}
This package contains the library needed to run programs dynamically
linked with libglib.

%files -n %{libname}
/%{_lib}/libglib-%{api}.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{libgio}
Summary:	%{summary}
Group:		%{group}

%description -n %{libgio}
This package contains the library needed to run programs dynamically
linked with libgio.

%files -n %{libgio}
/%{_lib}/libgio-%{api}.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{libgmodule}
Summary:	%{summary}
Group:		%{group}

%description -n %{libgmodule}
This package contains the library needed to run programs dynamically
linked with libgmodule.

%files -n %{libgmodule}
/%{_lib}/libgmodule-%{api}.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{libgobject}
Summary:	%{summary}
Group:		%{group}

%description -n %{libgobject}
This package contains the library needed to run programs dynamically
linked with libgobject.

%files -n %{libgobject}
/%{_lib}/libgobject-%{api}.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{libgthread}
Summary:	%{summary}
Group:		%{group}

%description -n %{libgthread}
This package contains the library needed to run programs dynamically
linked with libgthread.

%files -n %{libgthread}
/%{_lib}/libgthread-%{api}.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{gio}
Summary:	GIO is the input, output and streaming API of glib
Group:		%{group}
Provides:	gio2.0 = %{EVRD}

%description -n %{gio}
GIO is the input, output and streaming API of glib. It on the one hand
provides a set of various streaming classes to access data from different
sources in a convenient way and on the other hand it provides a high level
file system abstraction to access file and directories not only local but also
on the network. For the latter you need to install gvfs.

%files -n %{gio}
%{_bindir}/gio-querymodules-%{bit}
%{_mandir}/man1/gio-querymodules-%{bit}.1*
%if %{without bootstrap}
%dir %{_libdir}/gio/
%dir %{_libdir}/gio/modules/
%{_libdir}/gio/modules/libgiofam.so
%endif
%ghost %{_libdir}/gio/modules/giomodule.cache

%post -n %{gio}
%{_bindir}/gio-querymodules-%{bit} %{_libdir}/gio/modules

%triggerin -n %{gio} -- %{_libdir}/gio/modules/*.so
%{_bindir}/gio-querymodules-%{bit} %{_libdir}/gio/modules

%triggerpostun -n %{gio} -- %{_libdir}/gio/modules/*.so
%{_bindir}/gio-querymodules-%{bit} %{_libdir}/gio/modules

#----------------------------------------------------------------------------

%package -n %{devname}
Summary:	Static libraries and header files of %{name}
Group:		Development/C
Requires:	glib-gettextize = %{EVRD}
Requires:	%{name}-common = %{EVRD}
Requires:	%{libname} = %{EVRD}
Requires:	%{libgio} = %{EVRD}
Requires:	%{libgmodule} = %{EVRD}
Requires:	%{libgobject} = %{EVRD}
Requires:	%{libgthread} = %{EVRD}
Provides:	glib2-devel = %{EVRD}

%description -n %{devname}
Static libraries and header files for the support library for the GIMP's X
libraries, which are available as public libraries.  GLIB includes generally
useful data structures.

%files -n %{devname}
%doc AUTHORS ChangeLog NEWS
%doc %{_datadir}/gtk-doc/html/*
%{_libdir}/lib*.so
%{_libdir}/glib-%{api}/include/
%{_libdir}/pkgconfig/*
%{_includedir}/*
%{_mandir}/man1/glib-genmarshal.1*
%{_mandir}/man1/glib-mkenums.1*
%{_mandir}/man1/gobject-query.1*
%{_mandir}/man1/gtester-report.1*
%{_mandir}/man1/gtester.1*
%{_datadir}/aclocal/glib-%{api}.m4
%{_datadir}/aclocal/gsettings.m4
%{_bindir}/glib-genmarshal
%{_bindir}/glib-mkenums
%{_bindir}/gobject-query
%{_bindir}/gtester*
%{_datadir}/gdb/auto-load/%{_lib}/lib*-gdb.py
%{_datadir}/glib-%{api}/gdb/
%{_datadir}/glib-%{api}/codegen
%{_datadir}/bash-completion/completions/gresource
%{_bindir}/gdbus-codegen
%{_bindir}/glib-compile-resources
%{_bindir}/gresource
%{_mandir}/man1/gdbus-codegen.1*
%{_mandir}/man1/glib-compile-resources.1*
%{_mandir}/man1/gresource.1*

#----------------------------------------------------------------------------

%package -n glib-gettextize
Summary:	Gettextize replacement
Group:		Development/Other

%description -n glib-gettextize
%{name} package is designed to replace gettextize completely.
Various gettext related files are modified in glib and gtk+ to
allow better and more flexible i18n; however gettextize overwrites
them with its own copy of files, thus nullifying the changes.
If this replacement of gettextize is run instead, then all gnome
packages can potentially benefict from the changes.

%files -n glib-gettextize
%{_bindir}/glib-gettextize
%{_mandir}/man1/glib-gettextize.1*
%{_datadir}/aclocal/glib-gettext.m4
%{_datadir}/glib-%{api}/gettext/

#----------------------------------------------------------------------------

%prep
%setup -qn glib-%{version}
%apply_patches

%build
autoreconf -fi
%configure2_5x \
	--with-pcre=system \
	--enable-man \
	--disable-static \
%if %{with selinux}
	--enable-selinux \
%else
	--disable-selinux \
%endif
	--disable-systemtap \
	--with-runtime-libdir=../../%{_lib} \
%if %{without gtkdoc}
	--enable-gtk-doc=no
%endif

%make

%install
%makeinstall_std

mkdir -p %{buildroot}%{_sysconfdir}/profile.d
install -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/profile.d/50glib20.sh
install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/profile.d/50glib20.csh
%find_lang glib20

# remove files
find %{buildroot} -name "*.la" -delete
rm -f %{buildroot}%{_libdir}/gio/modules/lib*a

mv %{buildroot}%{_bindir}/gio-querymodules %{buildroot}%{_bindir}/gio-querymodules-%{bit}
mv %{buildroot}%{_mandir}/man1/gio-querymodules.1 %{buildroot}%{_mandir}/man1/gio-querymodules-%{bit}.1

#ghost files
touch %{buildroot}%{_libdir}/gio/modules/giomodule.cache \
      %{buildroot}%{_datadir}/glib-2.0/schemas/gschemas.compiled

#gw at the moment, don't ship these:
rm -f %{buildroot}%{_datadir}/systemtap/tapset/{glib,gobject}.stp


%changelog

* Thu Feb 08 2018 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1:2.54.2-2
- (6307e95) New version 2.54.2
- (6307e95) Re-diff no-warnings patch

* Fri Aug 04 2017 tremod <negry.m@yandex.ru> 1:2.52.3-1
- (88d8c51) Update to 2.52.3

* Fri Feb 24 2017 tremod <negry.m@yandex.ru> 1:2.50.3-1
- (6bb72cd) Update to 2.50.3

* Sat Feb 04 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1:2.50.2-3
- (7b6cdf4) MassBuild#1230: Increase release tag

* Mon Nov 07 2016 Nemial <negry.m@yandex.ru> 1:2.50.2-2
- (df26c26) Add to BReq gtk-doc

* Mon Nov 07 2016 tremod <negry.m@yandex.ru> 1:2.50.2-1
- (843b9cc) Update to 2.50.2

* Fri Oct 14 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1:2.50.0-2
- (507932a) MassBuild#1169: Increase release tag

* Thu Sep 29 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1:2.50.0-1
- (0f5de38) Build requires pkgconfig(mount)
- (Andrey Bondrov: 96cfa4d) New version 2.50.0
- (Andrey Bondrov: 96cfa4d) Update files (add gio binary and man page)

* Tue Sep 13 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1:2.48.2-1
- (59a8c2a) Add new files
- (Andrey Bondrov: 26d61e9) New version 2.48.2
- (Andrey Bondrov: 26d61e9) Spec cleanup

* Tue Sep 06 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1:2.44.1-2
- (15fbb45) Bump release

* Fri Jul 10 2015 Tigro <ashejn@yandex-team.ru> 1:2.44.1-1
- (9c3ab2d) drop glib2-do-not-unload.patch patch
- (Tigro: 76ee2da) update to 2.44.1

* Mon Jun 22 2015 din (Dmitry Fedorov) <d.fedorov@ntcit-rosa.ru> 1:2.40.0-8
- (a7716f7) add missed patch
- (din (Dmitry Fedorov): f23f908) link libgobject with a flag indicating that it can't be unloaded; fix #bz5805

* Mon May 25 2015 Denis Silakov <denis.silakov@rosalab.ru> 1:2.40.0-7
- (de6832c) Require python for devel package, not for the main one
- (Denis Silakov: c81c360) Require python, not python(abi)

* Mon May 25 2015 Denis Silakov <denis.silakov@rosalab.ru> 1:2.40.0-6
- (f60d920) Rebuild

* Wed May 13 2015 Tigro <ashejn@gmail.com> 1:2.44.1-1
- (65e6d3e) update to 2.44.1

* Mon Mar 23 2015 Tigro <ashejn@gmail.com> 1:2.44.0-1
- (d4eb647) update to 2.44.0

* Tue Mar 17 2015 Tigro <ashejn@yandex-team.ru> 1:2.43.92-1
- (aa5a405) update to 2.43.92

* Sun Mar 08 2015 Tigro <ashejn@gmail.com> 1:2.43.91-1
- (647c4fa) update to 2.43.91

* Sun Feb 22 2015 Alexander Lakhin <a.lahin@ntcit-rosa.ru> 1:2.40.0-5.2
- (757c3ee) MassBuild#656: Increase release tag

* Tue Feb 03 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1:2.40.0-5.1
- (0214e98) Adjust selinux build conditions

* Fri Jun 27 2014 Alex Burmashev <alex.burmashev@rosalab.ru> 1:2.40.0-4
- (a9a3ed6) MassBuild#440: Increase release tag

* Tue Jun 24 2014 Tigro <ashejn@gmail.com> 1:2.40.0-3
- (bb53675) bump release

* Tue Jun 24 2014 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1:2.40.0-2
- (81f1a70) Bump release

* Tue Apr 08 2014 Tigro <ashejn@gmail.com> 1:2.40.0-1
- (328d55e) pack files
- (Tigro: 3913cef) added source
- (Tigro: 8a196d0) update to 2.40.0

* Wed Mar 12 2014 Tigro <ashejn@gmail.com> 1:2.39.91-1
- (b082a63) update to 2.39.91

* Thu Oct 17 2013 Tigro <ashejn@gmail.com> 1:2.36.3-4
- (4bcfd96) fix https://bugzilla.gnome.org/show_bug.cgi?id=701609

* Mon Sep 09 2013 Tigro <ashejn@gmail.com> 1:2.36.3-3
- (b7894f3) added autoreconf


